close all; clear all;

%  IIM for general probem:
%
%    (\beta u_x)_x - \sigma u = f
%
%  with give jump in [u] and [\beta u_x].
%  The test example is: 
%    u(x) = sin(2x) if x < alf,   x \in (0,1)
%         = log(x)  if x > alf
%    beta(x) = 1 + x,  if x < alf,   
%            = x^2,    if x > alf
%    sigma(x) = cos(x),  if x < alf,   
%             = sin(x),  if x > alf
%    f(x) = (\beta u_x)_x - \sigma u 


alf = input('Input alf = ');
n = input('Input n = ');

h=1/n; x=0:h:1; x=x'; h1 =h*h;

C=zeros(n+1,n+1); b = zeros(n+1,1);
for i=1:n-1
   if  x(i) <=alf & alf< x(i+1)
      j = i;
   end
end

%A = sparse(n+1,n+1);
A = zeros(n+1,n+1);
A(1,1) = 1/h1; b(1) = uexact(x(1),alf)/h1;
A(n+1,n+1) = 1/h1; b(n+1)=uexact(x(n+1),alf)/h1;

for i=2:n                         % FD at regular grid points
   xl = x(i) - h/2; xr = x(i) + h/2;
   A(i,i-1) = my_beta(xl,alf)/h1;
   A(i,i+1) = my_beta(xr,alf)/h1;
   A(i,i) = - (A(i,i-1)+A(i,i+1)) - my_sigma(x(i),alf);
   b(i) = f(x(i),alf);
end

% At x=x(j)
B = zeros(3,3); Bb= zeros(3,1);
bl = my_beta(alf-1.0d-14,alf); br = my_beta(alf+1.0d-14,alf);
rho = bl/br;

sigma_l = my_sigma(alf-1.0d-14,alf); sigma_r= my_sigma(alf+1.0d-14,alf);
sigmaj = sigma_r - sigma_l;
bxl = my_beta_x(alf-1.0d-14,alf); bxr = my_beta_x(alf+1.0d-14,alf);

B(1,1) = 1; B(1,2) = 1; B(1,3) = 1 + sigmaj*(x(j+1)-alf)^2/(2*br);

B(2,1) = x(j-1) - alf; B(2,2) = x(j) - alf;
B(2,3) = (x(j+1)-alf)*rho + (bxl/br - bl*bxr/(br*br) )*(x(j+1)-alf)^2/2 ;

B(3,1) = (x(j-1)-alf)^2/2; B(3,2) = (x(j)-alf)^2/2; 
B(3,3) = rho*(x(j+1)-alf)^2/2;

Bb(1) = 0; Bb(2)=bxl; Bb(3) = bl;

cl = B\Bb;
 A(j,j-1) = cl(1); A(j,j) = cl(2) -sigma_l; A(j,j+1) = cl(3);

uj = uexact(alf+1.0d-14,alf) - uexact(alf-1.0d-14,alf);
uxj = br*ux_exact(alf+1.0d-14,alf) -bl* ux_exact(alf-1.0d-14,alf);
fj = f(alf+1.0d-14,alf) - f(alf-1.0d-14,alf);
b(j) = b(j) + cl(3)*( uj + (x(j+1)-alf)*uxj/br- ( bxr*uxj/(br*br) ...
   - sigma_r*uj/br - fj/br )*(x(j+1)-alf)^2/2 );

% At x=x(j+1)
B = zeros(3,3); Bb= zeros(3,1);

B(1,1) = 1- sigmaj*(x(j)-alf)^2/(2*bl); B(1,2) = 1; B(1,3) = 1;

B(2,1) = (x(j) - alf)/rho + (bxr/bl - br*bxl/(bl*bl) )*(x(j)-alf)^2/2; 
B(2,2) = x(j+1) - alf; B(2,3) = x(j+2)-alf;

B(3,1) = (x(j)-alf)^2/(2*rho); B(3,2) = (x(j+1)-alf)^2/2; 
B(3,3) = (x(j+2)-alf)^2/2;

Bb(1) = 0; Bb(2)=bxr; Bb(3) = br;

cl = B\Bb;
 A(j+1,j) = cl(1); A(j+1,j+1) = cl(2) - sigma_r; A(j+1,j+2) = cl(3);
b(j+1) = b(j+1) + cl(1)*( -uj + (alf-x(j))*uxj/bl - ( -bxl*uxj/(bl*bl) ...
   + sigma_l*uj/bl + fj/bl )*(x(j)-alf)^2/2 );

% Determine the truncation error at x(j) and x(j+1)
for i=1:n+1
   soln(i)=uexact(x(i),alf); % e(i)=soln(i)-U(i);
end

T1 = abs( A(j,j-1) *soln(j-1) + A(j,j)*soln(j) + A(j,j+1)*soln(j+1) ...
    - b(j) )
T2=abs(A(j+1,j)*soln(j)+ A(j+1,j+1)*soln(j+1) + A(j+1,j+2)*soln(j+2) - b(j+1))

U=A\b;
for i=1:n+1
   e(i)=soln(i)-U(i);
end

figure(1);  plot(x,U,'o',x,soln);
figure(2); plot(x,e)                    % Error plot

E = norm(e,inf)
